using System;
using System.Collections.Generic;
using System.Text;

using System.Security.Permissions;
using System.Runtime.InteropServices;

namespace TecnoComm {

    public class deviceBT : device {

        [StructLayout(LayoutKind.Sequential)]
        public class WSAData {
            public Int16 wVersion;
            public Int16 wHighVersion;
            public String szDescription;
            public String szSystemStatus;
            public Int16 iMaxSockets;
            public Int16 iMaxUdpDg;
            public IntPtr lpVendorInfo;
        }

        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Auto)]
        public class WSAQUERYSET {
            public Int32 dwSize = 0;
            public String szServiceInstanceName = null;
            public IntPtr lpServiceClassId;
            public IntPtr lpVersion;
            public String lpszComment;
            public Int32 dwNameSpace;
            public IntPtr lpNSProviderId;
            public String lpszContext;
            public Int32 dwNumberOfProtocols;
            public IntPtr lpafpProtocols;
            public String lpszQueryString;
            public Int32 dwNumberOfCsAddrs;
            public IntPtr lpcsaBuffer;
            public Int32 dwOutputFlags;
            public IntPtr lpBlob;
        }

        [DllImport("Ws2_32.DLL", CharSet = CharSet.Auto,
        SetLastError = true)]
        private extern static
            Int32 WSAStartup(Int16 wVersionRequested, WSAData wsaData);

        [DllImport("Ws2_32.DLL", CharSet = CharSet.Auto,
        SetLastError = true)]
        private extern static
            Int32 WSACleanup();

        [DllImport("Ws2_32.dll", CharSet = CharSet.Auto,
        SetLastError = true)]
        private extern static
            Int32 WSALookupServiceBegin(WSAQUERYSET qsRestrictions,
                Int32 dwControlFlags, ref Int32 lphLookup);


        [DllImport("Ws2_32.dll", CharSet = CharSet.Auto,
        SetLastError = true)]
        private extern static
            Int32 WSALookupServiceNext(Int32 hLookup,
                Int32 dwControlFlags,
                ref Int32 lpdwBufferLength,
                IntPtr pqsResults);

        [DllImport("Ws2_32.dll", CharSet = CharSet.Auto,
        SetLastError = true)]
        private extern static
            Int32 WSALookupServiceEnd(Int32 hLookup);


        class WSA {
            public bool isImplemented;

            public WSA() {
                WSAData wsaData = new WSAData();
                isImplemented = WSAStartup(0x0202, wsaData)==0;
            }

            ~WSA() {
                if (isImplemented) WSACleanup();
            }
        }

        static WSA wsa = null;

        const int NS_BTH = 16;

        // List devices of this type that are still available
        // RETURN: list of devices
        public string[] listDevices() {
            if (wsa == null) wsa = new WSA();
            if (wsa.isImplemented == false) return new string[0];

            /*
            WSAQUERYSET wsaq = new WSAQUERYSET();

            wsaq.dwSize = sizeof(WSAQUERYSET);
            wsaq.dwNameSpace = NS_BTH;
            wsaq.lpcsaBuffer = null;
            int iResult = WSALookupServiceBegin(&wsaq, LUP_CONTAINERS, &hLookup);
            */

            return new string[0];
        }

        // Open a device for communication
        // device: identify device to open: should be the index (0 based) of the device
        //         in the list obtained by listDevices
        // baud  : baud rate required for communication; other serial parameters are
        //         fixed: 8N1.
        // RETURN: true on success
        public bool open(int device, uint baud) {
            return false;
        }

        // Close device and releases it
        // RETURN: true on success
        public bool close() {
            return false;
        }

        // Sends a byte on the communication channel
        // b     : byte to send
        // RETURN: true on success
        public bool putByte(byte b) {
            return false;
        }

        // Get a byte from the communication channel
        // b     : if a byte is available, it is stored here
        // RETURN: true if a byte was retrieved
        public bool getByte(ref byte b) {
            return false;
        }

        // Empty input and output buffers
        // RETURN: true on success
        public bool flush() {
            return false;
        }

        // Synchronizes communication speed
        // RETURN: true synchronization succeeded
        public bool synchronize() {
            return false;
        }

        // Signal if the PC is ready (should map to DTR)
        // on: set to true to signal ready
        // RETURN: true on success
        public bool signal(bool on) {
            return false;
        }

    }
}