using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace IT_READER {
    public partial class frmPortSelect : Form {

        private TecnoComm.deviceRS232 deviceRS232;
        private TecnoComm.deviceUSB deviceUSB;
        private TecnoComm.deviceRS485 deviceRS485;

        public TecnoComm.device device;

        public frmPortSelect() {
            InitializeComponent();
            deviceRS232 = new TecnoComm.deviceRS232();
            deviceUSB = new TecnoComm.deviceUSB();
            deviceRS485 = new TecnoComm.deviceRS485();
        }

        private void btnComPortsRefresh_Click(object sender, EventArgs e) {
            lsbComPorts.Items.Clear();
            string[] ports = deviceRS232.listDevices();
            foreach (string s in ports) lsbComPorts.Items.Add(s);
            btnSelect.Enabled = false;
        }

        private void btnUsbPortsRefresh_Click(object sender, EventArgs e)
        {
            lsbUsbPorts.Items.Clear();
            string[] ports = deviceUSB.listDevices();
            foreach (string s in ports) lsbUsbPorts.Items.Add(s);
            btnSelect.Enabled = false;
        }

        private void btn485PortsRefresh_Click(object sender, EventArgs e) {
            lsb485Ports.Items.Clear();
            string[] ports = deviceRS485.listDevices();
            foreach (string s in ports) lsb485Ports.Items.Add(s);
            btnSelect.Enabled = false;
        }

        private void btnAbort_Click(object sender, EventArgs e) {
            deviceRS232 = null;
            Visible = false;
        }

        private void lsbComPorts_SelectedIndexChanged(object sender, EventArgs e) {
            btnSelect.Enabled = lsbComPorts.SelectedIndex >= 0; 
        }

        private void lsbUsbPorts_SelectedIndexChanged(object sender, EventArgs e)
        {
            btnSelect.Enabled = lsbUsbPorts.SelectedIndex >= 0; 
        }

        private void lsb485Ports_SelectedIndexChanged(object sender, EventArgs e) {
            btnSelect.Enabled = lsb485Ports.SelectedIndex >= 0;
        }

        private void btnSelect_Click(object sender, EventArgs e) {
            if (tabConnections.SelectedTab == tabRS232)
            {
                deviceRS232.open(lsbComPorts.SelectedIndex, 9600);
                device = deviceRS232;
                Visible = false;
            }
            else if (tabConnections.SelectedTab == tabUSB)
            {
                deviceUSB.open(lsbUsbPorts.SelectedIndex, 9600);
                device = deviceUSB;
                Visible = false;
            }
            else if (tabConnections.SelectedTab == tabRS485) {
                deviceRS485.open(lsb485Ports.SelectedIndex, 9600);
                device = deviceRS485;
                Visible = false;
            }

        }

        private void frmPortSelect_Shown(object sender, EventArgs e) {
            btnComPortsRefresh_Click(null,null);
            btnUsbPortsRefresh_Click(null, null);
            btn485PortsRefresh_Click(null, null);
        }

        private void lsbComPorts_DoubleClick(object sender, EventArgs e) {
            if (lsbComPorts.SelectedIndex >= 0) btnSelect_Click(null, null);
        }

        private void lsbUsbPorts_DoubleClick(object sender, EventArgs e)
        {
            if (lsbUsbPorts.SelectedIndex >= 0) btnSelect_Click(null, null);
        }

        private void lsb485Ports_MouseDoubleClick(object sender, MouseEventArgs e) {
            if (lsb485Ports.SelectedIndex >= 0) btnSelect_Click(null, null);
        }

        private void tabConnections_SelectedIndexChanged(object sender, EventArgs e)
        {   
            int n=-1;
            if (tabConnections.SelectedTab == tabRS232) n = lsbComPorts.SelectedIndex;
            else if (tabConnections.SelectedTab == tabUSB) n = lsbUsbPorts.SelectedIndex;
            btnSelect.Enabled = n >= 0;
        }

        private void btn485Test_Click(object sender, EventArgs e) {
            deviceRS485.open(lsb485Ports.SelectedIndex, 9600);

            if (deviceRS485.putByte(0xFF) && deviceRS485.putByte(0xFF)) {
                btn485Test.ForeColor = Color.Green;
            }
            else {
                btn485Test.ForeColor = Color.Red;
            }
            deviceRS485.close();
        }

        





    }
}